<template>
	<AtomIntersectionObserver @enter="enter" @leave="leave">
		<component :is="`h${headingLevel}`" :class="[$style.title, { [$style.shouldAppear]: shouldAppear }]">
			{{ title }}
		</component>
	</AtomIntersectionObserver>
</template>

<script>
import AtomIntersectionObserver from '@components/atom-intersection-observer';

export default {
	components: { AtomIntersectionObserver },

	props: {
		title: {
			type: String,
			required: true,
		},

		headingLevel: {
			type: Number,
			default: 2,
		},

		delay: {
			type: Number,
			default: 6000,
		},
	},

	data: () => ({ shouldAppear: true, fadeTimeout: null }),

	methods: {
		enter() {
			this.shouldAppear = true;

			this.fadeTimeout = setTimeout(() => {
				this.shouldAppear = false;
				this.fadeTimeout = null;
			}, this.delay);
		},

		leave() {
			const { fadeTimeout } = this;
			if (fadeTimeout) {
				clearTimeout(fadeTimeout);
				this.fadeTimeout = null;
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.title {
	opacity: 0;

	@include transition('fade');

	&.shouldAppear {
		opacity: 1;
	}
}
</style>
